package SLA4;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;

import com.metamaxim.modelscope.callbacks.Behaviour;
import com.metamaxim.modelscope.callbacks.Instance;

public abstract class AbstractIndicator extends Behaviour {
	
	public String getCaption()
	{
		Instance slo = this.getInstance("SLO");
		return this.getIndicatorValue() + " " + slo.getString("Norm Unit");
	}
	
	/**
	 * Return the indicator value as an Object.
	 * 
	 * @return
	 */
	public abstract Object getIndicatorValue();
	
	/**
	 * Returns the most recent measurement.
	 * 
	 * @param slaMonitor
	 * @return
	 */
	protected Instance getLastMeasurement(Instance slaMonitor)
	{
		SimpleDateFormat sdf = new SimpleDateFormat("dd-MM-yyy HH:mm:ss.sss");
		
		Instance theMeasurement = null;
		
		long youngest = 0l;
		for (Instance measurement: slaMonitor.selectByRef("RequestReply Measurement", "SLA Contract Monitor"))
		{
			long age = AddRequestReplyMeasurement.getTimeMillis( measurement.getString("Time Stamp"));
			if (youngest <=  age)
			{
				youngest = age;
				theMeasurement = measurement;
			}
		}
		
		return theMeasurement;
	}

}
