package SLA4;

public class DataTypeAbstractionInteger extends DataTypeAbstraction {

	@Override
	public Object cast(Object value) {
		if (value instanceof Long)
			return value;
		
		if (value instanceof Number)
			return new Long(((Number)value).longValue());
		
		return this.convert(value.toString());
	}

	@Override
	public Object convert(String value) {
		return new Long(value);
	}

	@Override
	public Object getLowest() {
		return Long.MIN_VALUE;
	}

	@Override
	public Object getHighest() {
		return Long.MAX_VALUE;
	}

	@Override
	public boolean ge(Object o1, Object o2) {
		return (Long)this.cast(o1) >= (Long)this.cast(o2);
	}

	@Override
	public boolean le(Object o1, Object o2) {
		return (Long)this.cast(o1) <= (Long)this.cast(o2);
	}

	@Override
	public Object add(Object o1, Object o2) {
		return (Long)this.cast(o1) + (Long)this.cast(o2);
	}

	@Override
	public boolean gt(Object o1, Object o2) {
		return (Long)this.cast(o1) > (Long)this.cast(o2);
	}
	
	@Override
	public boolean lt(Object o1, Object o2) {
		return (Long)this.cast(o1) < (Long)this.cast(o2);
	}

	@Override
	public Object mul(Object o1, Object o2) {
		return (Long)this.cast(o1) * (Long)this.cast(o2);
	}

	@Override
	public Object div(Object o1, Object o2) {
		return (Long)this.cast(o1) / (Long)this.cast(o2);
	}
	
	@Override
	public String toString(Object o1) {
		return Long.toString((Long)this.cast(o1));
	}
}
