package SLA4;

import com.metamaxim.modelscope.callbacks.Instance;

public class IndicatorPeriodPercent extends IndicatorPeriod {
	
	@Override
	public Object getIndicatorValue()
	{
		//
		//	Get the measured value
		//
		Object o = super.getIndicatorValue();
		if (o.equals(Double.NaN))
			return o;
		
		int value = (int)o;
		
		//
		//	Get the totalling attribute
		//
		Instance slaMonitor = this.getInstance("SLA Contract Monitor");
		
		Instance slo = this.getInstance("SLO");
		String period = slo.getString("Norm Period", "Period Value");
		
		String measurementAttributeName = this.getString("Measurement Attribute Total");
		
		int total = sum(slaMonitor, period, measurementAttributeName);
		
		//
		//	Calculate % of total
		//
		return Math.round(100f * (float)value/(float)total);
	}

}
