package SLA4;

import com.metamaxim.modelscope.callbacks.Behaviour;
import com.metamaxim.modelscope.callbacks.Event;

public class NormTimesSubsetInPeriod extends Behaviour {
	
	public String getCaption()
	{
		try
		{
			String unit = " " + this.getString("Norm Unit");
			String ssUnit = " " + this.getString("Unit Subset");
			return this.getString("Norm Criteria") + " " + this.getInteger("Norm Value") + unit + 
				" have " + ssUnit + " within " + Range.toString(this.getBoolean("Low Inclusive Subset"), this.getBoolean("Low Infinity Subset"), this.getString("Low Value Subset"), this.getBoolean("High Inclusive Subset"), this.getBoolean("High Infinity Subset"), this.getString("High Value Subset")) +
				" during a period of " + this.getString("Period Value");			
		}
		catch (RuntimeException e)
		{
			e.printStackTrace();
			throw e;
		}
	}

	public void processCreateNormTimesSubsetInPeriod(Event event, String subscript)
	{
		this.setBoolean("Low Infinity Subset", event.getString("Low Value Subset") == null || event.getString("Low Value Subset").trim().length() == 0);
		this.setBoolean("Low Inclusive Subset", true);
		this.setBoolean("High Infinity Subset", event.getString("High Value Subset") == null || event.getString("High Value Subset").trim().length() == 0);
		this.setBoolean("High Inclusive Subset", false);		
	}
	
	/**
	 * Utility method to copy Norm Period attribute values from one instance to another.
	 * @param to
	 * @param from
	public static void copyAttributes(Instance to, Instance from)
	{
		to.setString("Norm TimesSubset In Period", "Period Value", from.getString("Norm TimesSubset In Period", "Period Value"));
		to.setBoolean("Norm TimesSubset In Period", "Low Infinity Subset", from.getBoolean("Norm TimesSubset In Period", "Low Infinity Subset"));
		to.setBoolean("Norm TimesSubset In Period", "Low Inclusive Subset", from.getBoolean("Norm TimesSubset In Period", "Low Inclusive Subset"));
		to.setString("Norm TimesSubset In Period", "Low Value Subset", from.getString("Norm TimesSubset In Period", "Low Value Subset"));
		to.setBoolean("Norm TimesSubset In Period", "High Infinity Subset", from.getBoolean("Norm TimesSubset In Period", "High Infinity Subset"));
		to.setBoolean("Norm TimesSubset In Period", "High Inclusive Subset", from.getBoolean("Norm TimesSubset In Period", "High Inclusive Subset"));
		to.setString("Norm TimesSubset In Period", "High Value Subset", from.getString("Norm TimesSubset In Period", "High Value Subset"));
		to.setString("Norm TimesSubset In Period", "Unit Subset", from.getString("Norm TimesSubset In Period", "Unit Subset"));
		to.setString("Norm TimesSubset In Period", "Norm Criteria", from.getString("Norm TimesSubset In Period", "Norm Criteria"));
		to.setInteger("Norm TimesSubset In Period", "Norm Value", from.getInteger("Norm TimesSubset In Period", "Norm Value"));
		to.setString("Norm TimesSubset In Period", "Norm Unit", from.getString("Norm TimesSubset In Period", "Norm Unit"));		
	}
	 */
}
