package SLA4;

import com.metamaxim.modelscope.callbacks.Instance;

public class PenaltyCalculatorIncremental extends PenaltyCalculator {
	
	/**
	 * Calculates and returns the payable penalty as an attribute value.
	 */
	public int getPayablePenalty()
	{
		boolean violated = this.getBoolean("Violation");
		if (! violated)
			return 0;
		
		Instance slo = this.getInstance("SLO");
		int normValue = slo.getInteger("Norm Value");
		int indicatorValue = this.getInteger("Indicator Value");

		//
		//	Return a payable penalty which has a linear relation with the exceeded amount and the Penalty Value.
		//
		return (indicatorValue - normValue) * this.getInstance("SLO").getCurrency("Penalty Value");
	}


}
