package SLA4;

import com.metamaxim.modelscope.callbacks.Behaviour;
import com.metamaxim.modelscope.callbacks.Instance;

public class SLAContract extends Behaviour {
	
	public String getSLOCollection()
	{
		StringBuffer sb = new StringBuffer();
		int i = 0;

		//
		//	Collect all the captions for every SLO type available within this SLA.
		//
		for (String sloType: SLOTypes.getTypes())
		{
			//
			//	Get the SLO caption of every SLO found to be part of this SLA
			//
			for (Instance slo: this.selectByRef(sloType, "SLA Contract"))
			{
				if (i > 0)
					sb.append(";");

				sb.append(slo.getString("SLO Name") + " - Norm:" + slo.getString("Norm Caption") + " - Penalty: " + slo.getString("Penalty Caption"));

				i++;				
			}
		}
		
		//
		//	Return a string with SLO caption separated by a semi-colon.
		//
		return sb.toString();
	}
	
	public String getSLO1()
	{
		return getSLO(0);
	}
	public String getSLO2()
	{
		return getSLO(1);
	}
	public String getSLO3()
	{
		return getSLO(2);
	}
	public String getSLO4()
	{
		return getSLO(3);
	}
	public String getSLO5()
	{
		return getSLO(4);
	}
	public String getSLO6()
	{
		return getSLO(5);
	}
	public String getSLO7()
	{
		return getSLO(6);
	}
	public String getSLO8()
	{
		return getSLO(7);
	}
	public String getSLO9()
	{
		return getSLO(8);
	}
	public String getSLO10()
	{
		return getSLO(9);
	}
	public String getSLO11()
	{
		return getSLO(10);
	}
	public String getSLO12()
	{
		return getSLO(11);
	}
	
	/**
	 * Select the SLO caption of the SLO associated with the specified index.
	 *  
	 * @param i
	 * @return
	 */
	private String getSLO(int i)
	{
		String [] slos = this.getSLOCollection().split(";");
		if (slos.length == 0 || slos.length <= i)
			return "";
		
		return slos[i].trim();
	}

}
